import { useContext } from 'react';
import { ReactReduxContext } from 'react-redux';
export var useActionCreators = function useActionCreators() {
  var _useContext = useContext(ReactReduxContext),
      store = _useContext.store;

  var dispatch = store.dispatch;

  for (var _len = arguments.length, actionCreators = new Array(_len), _key = 0; _key < _len; _key++) {
    actionCreators[_key] = arguments[_key];
  }

  return actionCreators.map(function (actionCreator) {
    return function () {
      return dispatch(actionCreator.apply(void 0, arguments));
    };
  });
};