"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useActionCreators = void 0;

var _react = require("react");

var _reactRedux = require("react-redux");

var useActionCreators = function useActionCreators() {
  var _useContext = (0, _react.useContext)(_reactRedux.ReactReduxContext),
      store = _useContext.store;

  var dispatch = store.dispatch;

  for (var _len = arguments.length, actionCreators = new Array(_len), _key = 0; _key < _len; _key++) {
    actionCreators[_key] = arguments[_key];
  }

  return actionCreators.map(function (actionCreator) {
    return function () {
      return dispatch(actionCreator.apply(void 0, arguments));
    };
  });
};

exports.useActionCreators = useActionCreators;